# timeline-viewer

This template should help get you started developing with Vue 3 in Vite.

## Dependencies

- [Date-FNS](https://date-fns.org/v2.28.0/docs): date and formatting
- [Pinia](https://pinia.vuejs.org): Javascript Data Store
- [Vitest](https://vitest.dev/guide/): Unit test framework
- [Cypress](https://www.cypress.io/): E2E test framework

### Components

- [vue-csv-import](https://github.com/jgile/vue-csv-import): Simple CSV importer

## Recommended IDE Setup

[VSCode](https://code.visualstudio.com/) + [Volar](https://marketplace.visualstudio.com/items?itemName=johnsoncodehk.volar) (and disable Vetur) + [TypeScript Vue Plugin (Volar)](https://marketplace.visualstudio.com/items?itemName=johnsoncodehk.vscode-typescript-vue-plugin).

## Type Support for `.vue` Imports in TS

TypeScript cannot handle type information for `.vue` imports by default, so we replace the `tsc` CLI with `vue-tsc` for type checking. In editors, we need [TypeScript Vue Plugin (Volar)](https://marketplace.visualstudio.com/items?itemName=johnsoncodehk.vscode-typescript-vue-plugin) to make the TypeScript language service aware of `.vue` types.

If the standalone TypeScript plugin doesn't feel fast enough to you, Volar has also implemented a [Take Over Mode](https://github.com/johnsoncodehk/volar/discussions/471#discussioncomment-1361669) that is more performant. You can enable it by the following steps:

1. Disable the built-in TypeScript Extension
    1) Run `Extensions: Show Built-in Extensions` from VSCode's command palette
    2) Find `TypeScript and JavaScript Language Features`, right click and select `Disable (Workspace)`
2. Reload the VSCode window by running `Developer: Reload Window` from the command palette.

## Deployment

[website](https://opentooladd.gitlab.io/tools/timeline-viewer/): https://opentooladd.gitlab.io/tools/timeline-viewer/

Currently uses [Gitlab Pages](https://docs.gitlab.com/ee/user/project/pages/index.html)

For this there is a configuration set in `vite.config.ts` that sets the base path of the build files (javascript and css).
see https://vitejs.dev/guide/static-deploy.html#github-pages for more informations.

If the deployment method should change, the configuration should be there.

## Customize configuration

See [Vite Configuration Reference](https://vitejs.dev/config/).

## Project Setup

```sh
npm install
```

### Compile and Hot-Reload for Development

```sh
npm run dev
```

### Type-Check, Compile and Minify for Production

```sh
npm run build
```

### Run Unit Tests with [Vitest](https://vitest.dev/)

```sh
npm run test:unit
```

### Run End-to-End Tests with [Cypress](https://www.cypress.io/)

```sh
npm run build
npm run test:e2e # or `npm run test:e2e:ci` for headless testing
```

### Lint with [ESLint](https://eslint.org/)

```sh
npm run lint
```

## Job monitoring

**Install Wakeci**
Job defined for [Wakeci](https://github.com/jsnjack/wakeci)